"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.validationWarning = exports.validationError = exports["default"] = void 0;

var validationError = function validationError(meta, validateOnMount) {
  if (validateOnMount) {
    return meta.error || meta.submitError;
  }

  return meta.touched && (meta.error || meta.submitError);
};

exports.validationError = validationError;

var validationWarning = function validationWarning(meta, validateOnMount) {
  if (validateOnMount) {
    return meta.warning;
  }

  return meta.touched && meta.warning;
};

exports.validationWarning = validationWarning;
var helpers = {
  validationError: validationError,
  validationWarning: validationWarning
};
var _default = helpers;
exports["default"] = _default;